#Include Once "arraylist.bi"
#Include Once "fbgfx.bi"
#Include Once "IWindow.bi"
#Include Once "inc/sGUI/sGUI.bas"
#Include Once "inc/sGUI/SimpleToggle.bas"

'#Include Once "inc/sGUI/SimpleGadget.bas"

'
Type ColorPicker extends IWindow
	'Declare Constructor()
	Declare Constructor(e As sGUI.EventHandle Ptr,t As String,x As Integer,y As Integer,w As Integer,h As integer)
	Declare Destructor()

	Declare Function Pick(x As UInteger, y As uinteger) As color_t
	Declare Function lerp(v0 As double, v1 As Double, t As Double) As Double
	Declare Sub Render(e As sGUI.EventHandle Ptr)

	selected As color_t
	m_over As color_t
	img As IMAGE Ptr

End Type
Constructor ColorPicker(e As sGUI.EventHandle Ptr,t As String,x As Integer,y As Integer,w As Integer,h As integer)
'call IWindow.Init(...)
this.Init(e,t,y,x,w,h)

'create the rgb color square
img = ImageCreate(360,256,0,32)
Dim r As Double
Dim g As Double
Dim b As Double
Dim c1 As color_t
Dim c2 As color_t
Dim cw As color_t
Dim cb As color_t
Dim cr As color_t
cw.c=&h00ffffff
cb.c=&h00000000

For x As UInteger=0 To 360/6
	For y As UInteger=0 To 128
		c1.c=&hffff0000
		c2.c=&hffffff00
		r=lerp(c1.r,c2.r,x/60)
		g=lerp(c1.g,c2.g,x/60)
		b=lerp(c1.b,c2.b,x/60)

		cr.r=lerp(r,cw.r,y/128)
		cr.g=lerp(g,cw.g,y/128)
		cr.b=lerp(b,cw.b,y/128)
		PSet img,(x,y+128),cr.c
		cr.r=lerp(cb.r,r,y/128)
		cr.g=lerp(cb.g,g,y/128)
		cr.b=lerp(cb.b,b,y/128)
		PSet img,(x,y),cr.c

		c1.c=&hffffff00
		c2.c=&hff00ff00
		r=lerp(c1.r,c2.r,x/60)
		g=lerp(c1.g,c2.g,x/60)
		b=lerp(c1.b,c2.b,x/60)

		cr.r=lerp(r,cw.r,y/128)
		cr.g=lerp(g,cw.g,y/128)
		cr.b=lerp(b,cw.b,y/128)
		PSet img,(x+60,y+128),cr.c
		cr.r=lerp(cb.r,r,y/128)
		cr.g=lerp(cb.g,g,y/128)
		cr.b=lerp(cb.b,b,y/128)
		PSet img,(x+60,y),cr.c

		c1.c=&hff00ff00
		c2.c=&hff00ffff
		r=lerp(c1.r,c2.r,x/60)
		g=lerp(c1.g,c2.g,x/60)
		b=lerp(c1.b,c2.b,x/60)

		cr.r=lerp(r,cw.r,y/128)
		cr.g=lerp(g,cw.g,y/128)
		cr.b=lerp(b,cw.b,y/128)
		PSet img,(x+120,y+128),cr.c
		cr.r=lerp(cb.r,r,y/128)
		cr.g=lerp(cb.g,g,y/128)
		cr.b=lerp(cb.b,b,y/128)
		PSet img,(x+120,y),cr.c

		c1.c=&hff00ffff
		c2.c=&hff0000ff
		r=lerp(c1.r,c2.r,x/60)
		g=lerp(c1.g,c2.g,x/60)
		b=lerp(c1.b,c2.b,x/60)

		cr.r=lerp(r,cw.r,y/128)
		cr.g=lerp(g,cw.g,y/128)
		cr.b=lerp(b,cw.b,y/128)
		PSet img,(x+180,y+128),cr.c
		cr.r=lerp(cb.r,r,y/128)
		cr.g=lerp(cb.g,g,y/128)
		cr.b=lerp(cb.b,b,y/128)
		PSet img,(x+180,y),cr.c

		c1.c=&hff0000ff
		c2.c=&hffff00ff
		r=lerp(c1.r,c2.r,x/60)
		g=lerp(c1.g,c2.g,x/60)
		b=lerp(c1.b,c2.b,x/60)

		cr.r=lerp(r,cw.r,y/128)
		cr.g=lerp(g,cw.g,y/128)
		cr.b=lerp(b,cw.b,y/128)
		PSet img,(x+240,y+128),cr.c
		cr.r=lerp(cb.r,r,y/128)
		cr.g=lerp(cb.g,g,y/128)
		cr.b=lerp(cb.b,b,y/128)
		PSet img,(x+240,y),cr.c

		c1.c=&hffff00ff
		c2.c=&hffff0000
		r=lerp(c1.r,c2.r,x/60)
		g=lerp(c1.g,c2.g,x/60)
		b=lerp(c1.b,c2.b,x/60)

		cr.r=lerp(r,cw.r,y/128)
		cr.g=lerp(g,cw.g,y/128)
		cr.b=lerp(b,cw.b,y/128)
		PSet img,(x+300,y+128),cr.c
		cr.r=lerp(cb.r,r,y/128)
		cr.g=lerp(cb.g,g,y/128)
		cr.b=lerp(cb.b,b,y/128)
		PSet img,(x+300,y),cr.c
	Next
Next

active=TRUE
minimized = FALSE

End Constructor

Destructor ColorPicker()
ImageDestroy img
Delete event 'Lschen eines EventHandles
End Destructor
Sub ColorPicker.Render(e As sGUI.EventHandle Ptr)
	If active Then
		'this.event->XSleep(-1)
		'PreRender()
		If minimized=FALSE Then
			sGUI.FillE(x+16,y+h-32-16,32,32,m_over.c,,1,0)
			sGUI.FillE(x+16+32+16,y+h-32-16,32,32,selected.c,,1,0)
			Put(x+16,y+32),img,PSet
			If focus=TRUE Then
				If (sGUI.MOUSEX>=x+16) And (sGUI.MOUSEX<=x+w-16) Then
					If (sGUI.MOUSEY>=y+32) And (sGUI.MOUSEX<=y+h-32-16) Then
						If (sGUI.LMB) Then selected.c=Point(sGUI.MOUSEX-x-16,sGUI.MOUSEY-y-32,img)
						m_over.c=Point(sGUI.MOUSEX-x-16,sGUI.MOUSEY-y-32,img)
					EndIf
				EndIf
			EndIf
			Draw String (x+w-128-16-64,y+h-64+16),"&h" & Hex(m_over.r,2) & " " & "&h" & Hex(m_over.g,2) & " " & "&h" & Hex(m_over.b,2),sGUI.TextColor
			Draw String (x+w-128-16-64,y+h-64+32),"&h" & Hex(selected.r,2) & " " & "&h" & Hex(selected.g,2) & " " & "&h" & Hex(selected.b,2),sGUI.TextColor
		EndIf
	endif
End Sub
Function ColorPicker.lerp(v0 As double, v1 As Double, t As Double) As Double
	return (1.0 - t) * v0 + t * v1
End Function
