#Include Once "inc/sGUI/sGUI.bas"
'#Include Once "inc/sGUI/SimpleGadget.bas"
#Include Once "inc/sGUI/SimpleToggle.bas"
#Include Once "IWindow.bi"

Type WindowManager
	Declare Constructor()
	Declare Constructor(w As Integer,h As Integer)
	Declare Destructor()
	Declare Sub Render()
	Declare Sub UpdateZ()
	Declare Sub Sort()
	Declare Sub AddWindow(w As IWindow Ptr)
	Declare Sub DeleteWindow(w As IWindow Ptr)

	Windows As arrayList 'holds a list of IWindows

	event As sGUI.EventHandle Ptr
	w As Integer
	h As Integer
End Type
constructor WindowManager()

End Constructor
Constructor WindowManager(w As Integer,h As Integer)
this.w=w
this.h=h
event = New sGUI.EventHandle
sGUI.LoadProportionalFont(".\inc\Ubuntu\Ubuntu-R\Ubuntu-R.bmp")
sGUI.LoadFixedFont("Ubuntu\UbuntuMono-R\UbuntuMono-R.bmp")
End Constructor
Destructor WindowManager()
If Windows.count>0 Then
	For i As UInteger=0 To Windows.count-1
		Windows.removeLast()
	Next
EndIf
'Delete event
End Destructor
Sub WindowManager.AddWindow(w As IWindow Ptr)
	Dim IW As IWindow Ptr
	'setze den focus aller bisherigen fenster auf false
	If Windows.count>0 Then
		For i As UInteger=0 To Windows.count-1
			IW = Windows.get(i)
			IW->focus=FALSE
			Windows.insert(IW,i)
			Windows.remove(i+1)
		Next
	EndIf
	'nur das neue fenster bekommt den focus
	w->focus=TRUE
	Windows.add(w)
End Sub
Sub WindowManager.DeleteWindow(w As IWindow Ptr)
	If Windows.count>0 Then
		Windows.remove(w)
	EndIf
End Sub
Sub WindowManager.Sort()
	'holt das fenster mit Focus TRUE nach vorn
	'es kann immer nur ein fenster den focus haben
	Dim IW As IWindow Ptr
	If Windows.count>0 Then
		'hole letztes fenster mit focus und setze FALSE
		IW = Windows.get(Windows.count-1)
		IW->focus=FALSE
		Windows.removeLast()
		Windows.add(IW)
		'suche das fenster das geklickt wurde (focus=true) und hole es nach von
		For i As UInteger=0 To Windows.count-1
		IW = Windows.get(i)
			If IW->focus=TRUE Then
				Windows.Remove(i)
				Windows.add(IW)
			endif
		Next
	EndIf

End Sub
Sub WindowManager.Render()
	Sort()
	event->XSleep(-1)
	Dim IW As IWindow Ptr
	'Dim IW1 As IWindow Ptr
	'If Windows.count>1 Then
	'	For i As UInteger=0 To Windows.count-2
	'		IW = Windows.get(i)
	'		IW1 = Windows.get(i+1)
	'		If IW->z <= IW1->z Then Swap IW,IW1
	'	Next
	'EndIf

	If Windows.count>0 Then
		For i As Integer=0 To Windows.count-1 'To 0 Step -1
			IW = Windows.get(i)
			IW->PreRender(event)
			IW->Render(event)
		Next
	EndIf
End Sub
