#Include Once "inc/sGUI/sGUI.bas"
#Include Once "inc/sGUI/SimpleToggle.bas"
#Include Once "inc/sGUI/DragBar.bas"
'#Include Once "inc/sGUI/SimpleGadget.bas"

Type IWindow extends object
	Declare Constructor()
	Declare Sub Init(e As sGUI.EventHandle Ptr,t As String,x As Integer,y As Integer,w As Integer,h As integer)
	Declare virtual Destructor()

	Declare Sub PreRender(e As sGUI.EventHandle ptr)
	Declare virtual Sub Render(e As sGUI.EventHandle Ptr)

	title As String
	x As Integer
	y As Integer
	w As Integer
	h As Integer
	focus As boolean

	Xbutton As sGUI.Gadget Ptr
	Mbutton As sGUI.Gadget Ptr
	TitleBar As sGUI.Gadget Ptr

	'	Gadgets As arrayList
	'	UserData As arrayList
	event As sGUI.EventHandle Ptr

	active As boolean
	minimized As boolean

	Enum IGadget_e
	XButton
	MButton
	End Enum


End Type
Constructor IWindow()

End Constructor
sub IWindow.Init(e As sGUI.EventHandle Ptr,t As String,x As Integer,y As Integer,w As Integer,h As integer)
	this.x=x
	this.y=y
	this.w=w
	this.h=h
	this.focus=FALSE
	this.title = t
	event = New sGUI.EventHandle
	'wenn event = e dann alle fenster an selbe position dafuer aber verschiebbar
	'ansonsten alle fenster an ihrer position dafuer reagieren sie nur auf den workaraund zum focus setzen
	Xbutton = sGUI.AddSimpleGadget(event,w-16,1,14,14,"X")
	Mbutton = sGUI.AddSimpleGadget(event,w-32,1,14,14,"-")
	TitleBar = sGUI.AddDragBar(event,x,y,w,16,t)
End Sub
Destructor IWindow()
Delete event
End Destructor

Sub IWindow.PreRender(e As sGUI.EventHandle Ptr)
	'wenn fenster nicht geschlossen
	If active Then
		event->XSleep(-1)
		sGUI.GadgetOn(TitleBar)
		'Fenster position anpassen
		x=TitleBar->event->guiposX
		y=TitleBar->event->guiposY
		sGUI.GadgetOn(Xbutton)
		sGUI.GadgetOn(Mbutton)
		If focus=TRUE Then
			if e->GADGETMESSAGE then 'Abfrage ob eine GADGETMESSAGE anliegt wenn ja dann...
				select case event->GADGETMESSAGE 'Select-Case-Block fr die Auswertung der GADGETMESSAGE
					case Xbutton 'wurde unser Button gedrckt...
						active = Not active
					case Mbutton 'wurde unser Button gedrckt...
						minimized = Not minimized
					Case TitleBar
						'wenn DragBar geklickt setze Focus auf TRUE (klappt nich daher siehe unten)
						this.focus=TRUE
				End Select
			EndIf
		Else
			'workaround wenn DragBar geklickt setze focus
			select case sGUI.LMB
				case sGUI.HOLD
					If (sGUI.MOUSEX>x) And (sGUI.MOUSEX<x+w-32) Then
						If (sGUI.MOUSEY>y) And (sGUI.MOUSEY<y+16) Then
							this.focus=TRUE
						EndIf
					EndIf
			end Select

		endif
		'wenn minimiert nur dragbar anzeigen ansonsten body zeichnen
		If minimized=FALSE Then
			sGUI.FillE(x,y+16,w,h-16,,,1,0)
		EndIf
	Else
		sGUI.GadgetOff(Xbutton)
		sGUI.GadgetOff(Mbutton)
		sGUI.GadgetOff(TitleBar)
	EndIf
End Sub
Sub IWindow.Render(e As sGUI.EventHandle Ptr)

End Sub
